Bug 57261 - Align /vminfo and /threaddump with other Manager commands and document them
Align /vminfo and /threaddump with other Manager commands and document them
Status: RESOLVED FIXED
Product: Tomcat 8
Classification: Unclassified
Component: Manager
8.0.15
PC All
: P2 normal (vote)
: ----
Assigned To: Tomcat Developers Mailing List
:
Depends on:
Blocks:
  Show dependency tree
 
Reported: 2014-11-25 22:38 UTC by Konstantin Kolinko
Modified: 2014-12-08 07:32 UTC (History)
0 users



Attachments
Resolve 1 and 2 task item (5.19 KB, patch)
2014-11-27 08:14 UTC, Oleg Trokhov
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Konstantin Kolinko 2014-11-25 22:38:49 UTC
ManagerServlet supports the following commands that are not yet documented:

http://localhost:8080/manager/text/vminfo
http://localhost:8080/manager/text/threaddump

For reference see r1476960 (in 8.0.0) and r1578256 (in 8.0.4).

TODO:
1. It is documented that all Manager commands have output that starts with "OK".
These commands do not have an "OK" line, but start their output with a date. It is wrong and has to be fixed.

This includes the need to fix VminfoTask and ThreaddumpTask Ant tasks (r1578256).

2. Document them in manager-howto.html

3. Maybe mention them in Javadoc for ManagerServlet class, like other commands are listed there.
Comment 1 Oleg Trokhov 2014-11-27 08:14:53 UTC
Created attachment 32231 [details]
Resolve 1 and 2 task item
Comment 2 Oleg Trokhov 2014-11-27 08:17:50 UTC
1. I added "OK" and some short description to responces, but what you mean about "need to fix VminfoTask and ThreaddumpTask Ant tasks"?
2. Added
3. This comments alredy exist in ManagerServlet class
Comment 3 Konstantin Kolinko 2014-11-27 08:30:43 UTC
(In reply to Oleg Trokhov from comment #2)

There exist org.apache.catalina.ant.VminfoTask and ThreaddumpTask classes that are used as tasks in Ant. They call those manager commands via HTTP and parse their response. They should not stop working with the change of the output format.
Comment 4 Oleg Trokhov 2014-11-27 08:37:53 UTC
I found this classes, they have only these code:
   
 public void execute() throws BuildException {

        super.execute();
        execute("/threaddump");

    }
Output from manager commands doesn't broken, all work fine. Or I misunderstood  something?
Comment 5 Konstantin Kolinko 2014-11-27 08:46:16 UTC
(In reply to Oleg Trokhov from comment #4)

OK. Thank you.

Before looking at the source code I thought that there was some built-in change in behaviour. Actually there is an explicit configuration setting available (ignoreResponseConstraint attribute on AbstractCatalinaTask), that allows to turn off parsing of the first line of the response.
Comment 6 Konstantin Kolinko 2014-12-08 05:16:52 UTC
Fixed in trunk and 8.0.x (r1643737) and will be in 8.0.16 onwards.
Comment 7 Konstantin Kolinko 2014-12-08 07:32:58 UTC
I ported /vminfo and /threaddump commands to Tomcat 7 (r1643750, r1643754). They will be in 7.0.58 onwards.